HOST = "";
TOKEN = "";

local hex_to_char = function(x)
    return string.char(tonumber(x, 16))
end
  
local unescape = function(url)
    return url:gsub("%%(%x%x)", hex_to_char)
end

function on_load_hook()
    print("Loading Alist script")
    local path = mp.get_property("path", "")
    local url_path = string.match(path, HOST .. "/d/(.*)")
    if url_path == nil then
        url_path = string.match(path, HOST .. "/dav/(.*)")
    end
    if url_path then
        local data = get_alist_path(unescape(url_path))
        local new_url = data["url"]
        set_http_headers(data["headers"])        
        print("Loading Alist script")        
        mp.osd_message("打开: " .. new_url, 8)
        mp.set_property("stream-open-filename", new_url)
    end
end

mp.add_hook("on_load", 50, on_load_hook)

function set_http_headers(http_headers)
    if not http_headers then
        return
    end
    local headers = {}
    for idx, item in pairs(http_headers) do    
        local field_value = item["name"]

        if field_value == "User-Agent" then
            mp.set_property("file-local-options/user-agent", item["value"])
        else
            if field_value then
                headers[#headers + 1] = item["name"] .. ": " .. item["value"]
            end
        end
    end
    if #headers > 0 then
        mp.set_property_native("file-local-options/http-header-fields", headers)
    end
end

function get_alist_path(path)
    local utils = require 'mp.utils'
    path_body = {}
    path_body["path"]=path
    request_body = utils.format_json(path_body)

    ret = mp.command_native({
        name = "subprocess",
        args = {
            "curl", "-s", "-X", "POST",
            HOST .. "/api/admin/link",
            "-H", "Accept: application/json",
            "-H", "Authorization: " .. TOKEN,
            "-H", "Content-Type: application/json;charset=UTF-8",
            "-d", request_body
        },
        capture_stdout=true
    })
    local resp_json, err = utils.parse_json(ret.stdout)
    return resp_json["data"]
end